#include <inttypes.h>

uint64_t
htonll (uint64_t hostlonglong)
{
#if defined(__i386) || defined(__x86_64)
  uint64_t netlonglong;
  uint8_t * byte = (uint8_t *) &netlonglong;

  byte[0] = (uint8_t) ((hostlonglong >> 56) & 0xFF);
  byte[1] = (uint8_t) ((hostlonglong >> 48) & 0xFF);
  byte[2] = (uint8_t) ((hostlonglong >> 40) & 0xFF);
  byte[3] = (uint8_t) ((hostlonglong >> 32) & 0xFF);
  byte[4] = (uint8_t) ((hostlonglong >> 24) & 0xFF);
  byte[5] = (uint8_t) ((hostlonglong >> 16) & 0xFF);
  byte[6] = (uint8_t) ((hostlonglong >> 8) & 0xFF);
  byte[7] = (uint8_t) ((hostlonglong >> 0) & 0xFF);

  return netlonglong;
#else
  return hostlonglong;
#endif
}

uint64_t
ntohll (uint64_t netlonglong)
{
#if defined(__i386) || defined(__x86_64)
  uint64_t hostlonglong;
  uint8_t * byte = (uint8_t *) &hostlonglong;

  byte[0] = (uint8_t) ((netlonglong >> 56) & 0xFF);
  byte[1] = (uint8_t) ((netlonglong >> 48) & 0xFF);
  byte[2] = (uint8_t) ((netlonglong >> 40) & 0xFF);
  byte[3] = (uint8_t) ((netlonglong >> 32) & 0xFF);
  byte[4] = (uint8_t) ((netlonglong >> 24) & 0xFF);
  byte[5] = (uint8_t) ((netlonglong >> 16) & 0xFF);
  byte[6] = (uint8_t) ((netlonglong >> 8) & 0xFF);
  byte[7] = (uint8_t) ((netlonglong >> 0) & 0xFF);

  return hostlonglong;
#else
  return netlonglong;
#endif
}
